%read from file.
clc;
format short;
gpsCoordinates = 'data_GPSext.dat';      % File must be in same directory
model = 'data_Corrections.dat';      % File must be in same directory

if(exist('firstrun','var')) % If it's the first run, this is not true.
    clc;
    c = 0;
    for phi = 0:1:w-1       %for each latitude
        c = c + 1;
        clc;
        100*c/w         
        phiCurrent = angleTable(1+(phi),2);

        for lamda = 0:1:w-1 %For each longitude 
            lamdaCurrent = angleTable(1+(phi),1);
            Ntot = 0;               % Reset N for new angle pair
            nSum = 0;               % Reset sum n
            mSumOne = 0;

            for n = 0:nMax
            mSum = 0;               % Reset sum m

                for m = 0:n
                    mSumOne = (Jnm(1+(n),1+(m))*cos(m*lamdaCurrent)+Knm(1+(n),1+(m))*sin(m*lamdaCurrent))* P(1+(n),1+(m));
                    mSum = mSum + mSumOne;
                end

                Ntot = Ntot + mSum;
            end
            Ntot = Ntot * constOutside;
            geomTable(1+(phi),3) = Ntot;
        end
    end
    geomTable
    
else % it is first run
    fid = fopen(gpsCoordinates);
        C = textscan(fid, '%f %f');
        long=C{2};             % Fetch longitude
        lat=C{1};              % Fetch latitude
        w = length(long);      % Number of angle pairs
        angleTable = zeros(w,2);

    fid2 = fopen(model);
        D = textscan(fid2, '%f %f %f %f');
        nFile=D{1};             % Fetch n
        mFile=D{2};             % Fetch m
        jnmFile=D{3};           % Fetch j_nm
        knmFile=D{4};           % Fetch k_nm

        nMax = nFile(length(nFile)); 
        mMax = nMax;            % Set max values for n and m

    gamma = 9.81;           % Grav. acceleration    [m*s^-2]
    G = 6.67384*10^-11 ;    % Grav. Constant [m^3*kg^-1*s^-2]
    rho = 2670;             % Av. earth density [kg*m^3]
    mu = G*rho;
    constOutside = -2*pi*mu/gamma;
    c = 0;
    geomTable = zeros(length(long),3);

    % Initiate result tables
    for i = 0:w-1
        geomTable(1+(i),1) = long(1+(i));
        geomTable(1+(i),2) = lat(1+(i));
        angleTable(1+(i),1) = deg2rad(geomTable(1+(i),1));
        angleTable(1+(i),2) = deg2rad(geomTable(1+(i),2));
    end

    % Initiate R, P and q matrix. Set to zero.
    P = zeros(nMax+1,mMax+1);   
    Jnm = zeros(nMax+1,mMax+1);
    Knm = zeros(nMax+1,mMax+1);
    
    % Calculate Jnm and Knm-matrix 
    for n = 0:nMax          
        Jnm(1+(n),1+(0)) = jnmFile(1+(c));
        Knm(1+(n),1+(0)) = knmFile(1+(c));
        for m = 1:n
            c = c + 1;
            Jnm(1+(n),1+(m)) = jnmFile(1+(c));
            Knm(1+(n),1+(m)) = knmFile(1+(c));
        end
        c = c + 1;
    end  

    c = 0;
    % Calculate P-matrix (runtime is approx (n^2)/2 times length of coordinate list)
    for phi = 0:1:w-1
        c = c + 1;
        clc;
        100*c/w         
        phiCurrent = angleTable(1+(phi),2);

        t = sin(phiCurrent);% Now insert initial P parameters
        P(1+(0),1+(0)) = 1; 
        P(1+(1),1+(0)) = t*sqrt(3); 
        P(1+(1),1+(1)) = sqrt(3)*sqrt(1-t^2);
    
        for n = 0:nMax      % Calculate rest of P-matrix
            for m = 0:n
                %First rule
                if (n>=2 && m==0)
                    P(1+(n),1+(0)) = -(sqrt(2*n+1)/n)*((n-1)/sqrt(2*n-3))*P(1+(n-2),1+(0))+t*(sqrt(2*n+1)/n)*sqrt(2*n-1)*P(1+(n-1),1+(0));

                %Second rule
                elseif (n>=2 && m==n)
                    P(1+(n),1+(n)) = sqrt((2*n+1)/(2*n))*sqrt(1-t^2)*P(1+(n-1),1+(n-1));

                %Third rule
                elseif (n>=1 && m==(n-1))
                    P(1+(n),1+(n-1)) = t*sqrt(2*n+1)*P(1+(n-1),1+(n-1));          

                %Fourh rule
                elseif (n>=3 && 1<=m && m<=(n-2))
                    P(1+(n),1+(m)) = -sqrt(((2*n+1)*(n+m-1)*(n-m-1))/((2*n-3)*(n+m)*(n-m)))*P(1+(n-2),1+(m))+t*sqrt(((2*n+1)*(2*n-1))/((n+m)*(n-m)))*P(1+(n-1),1+(m));
                end
            end
        end
    end
firstrun = 1;
disp('First run is done. First elements of P matrix are');
P(1:10,1:10)
end




