
%% Making the grid matrix

% Read in the fil manually and name it data
% The GPS points schould be read in manually and named GPS

close all

if length(data)==364485
    A=zeros(1551,1880);
    B=data;
    n=1551;
    
    for j=1:1551
        m=1;
        for i=1:8:1880
            A(n,i:i+7)=B(((j-1)*235)+m,:);
            B(((j-1)*235)+m,:)=0;
            m=m+1;
        end
        n=n-1;
    end
    [m,n] = size(A)
    for i=1:m
        for j=1:n
            if A(i,j)==9999
                A(i,j)=15;
            end
        end
    end
    
    x = -35:0.04:40.16;
    y = 53:0.02:84;
    Z = A; 
    [Xm,Ym] = meshgrid(-35:0.04:40.16,53:0.02:84);
else
    A=zeros(1001,1001);
    B=data;
    n=1001;
    
    for j=1:1001
        m=1;
        for i=1:7:1001
            A(n,i:i+6)=B(((j-1)*143)+m,:);
            B(((j-1)*143)+m,:)=0;
            m=m+1;
        end
        n=n-1;
    end

    x = -5:0.04:35;
    y = 55:0.02:75;
    Z = A;
    [Xm,Ym] = meshgrid(-5:0.04:35,55:0.02:75);
end

XP=GPS(:,1);
YP=GPS(:,2);

[Y,X] = meshgrid(x',y);
ZP= interp2(Y,X,Z,YP,XP,'bicubic');
save('grid.dat', 'ZP','-ASCII');
x=XP;
y=YP;
Z0=GPS(:,5);
z=abs(ZP-Z0);

fig('units','centimeters','width',10,'height',9.2,'font','Helvetica','fontsize',11);
set(gcf, 'renderer', 'zbuffer');
colorbar south;
axesm('MapProjection', 'Lambert','MapLatLimit',[57 72], 'MapLonLimit',[0 35], 'grid', 'on'); framem; gridm; 
    % Set the cosmetics of the map
    mlabel on; plabel on; gridm on;
    setm(gca,'MLabelLocation',[0 10 20 30])
    setm(gca,'MLineLocation',[0 10 20 30])
    setm(gca,'PLabelLocation',[55 60 65  70])
    setm(gca,'PLineLocation',[55 60 65  70])
    set(gca,'Ylim',[0.84 1.2]);
    set(gca, 'visible', 'off');
    T = get(gca,'tightinset');
    set(gca,'position',[T(1) T(2) 1-T(1)-T(3) 1-T(2)-T(4)]);

geoshow('ne_50m_ocean.shp','FaceColor',[.816 .910 .996], 'EdgeColor', [0.3 0.3 0.3]);
surfm(Ym,Xm,A);
[c,h] = contourm(Ym,Xm,A,'LineColor',[0 0 0],'LineWidth',1.5,'LineStyle','-');
ht = clabelm(c,h);
set(ht,'Color','black','BackgroundColor','white','FontWeight','bold');
caxis([10 50]);
